# mypy-boto3-importexport

[![PyPI - mypy-boto3-importexport](https://img.shields.io/pypi/v/mypy-boto3-importexport.svg?color=blue)](https://pypi.org/project/mypy-boto3-importexport)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-importexport.svg?color=blue)](https://pypi.org/project/mypy-boto3-importexport)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.ImportExport 1.14.20](https://boto3.amazonaws.com/v1/documentation/api/1.14.20/reference/services/importexport.html#ImportExport) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.2.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to install

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `ImportExport` service.

```bash
python -m pip install boto3-stubs[importexport]
```

## How to use

### Client annotations

`ImportExportClient` provides annotations for `boto3.client("importexport")`.

```python
import boto3

from mypy_boto3_importexport import ImportExportClient
from mypy_boto3_importexport.paginator import ListJobsPaginator
from mypy_boto3_importexport.type_defs import ArtifactTypeDef, ...

client: ImportExportClient = boto3.client("importexport")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ImportExportClient = session.client("importexport")
```

### Paginators annotations

`mypy_boto3_importexport.paginator` module contains type annotations for all paginators.

```python

client: ImportExportClient = boto3.client("importexport")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_jobs_paginator: ListJobsPaginator = client.get_paginator("list_jobs")
```







### Typed dictionations

`mypy_boto3_importexport.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python

def get_structure() -> ArtifactTypeDef:
    return {
      ...
    }
```


## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_importexport` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("importexport")

session_client = boto3.Session().client("importexport")
```
